clc;
clear all;

addpath('d:\dynare\4.5.7\matlab')
data = xlsread('estimation_data.xlsx');
date_series = x2mdate(data(1:end,1));
idx = find(date_series>datenum(1983,12,31),1,'first');

% data_growth = data(1:end-1,2) - mean(data(1:end-1,2));
% data_r = log(data(1:end-1,5)./mean(data(1:end-1,5)));
% data_inflation = log(data(1:end-1,4)./mean(data(1:end-1,4)));
% data_rlong = log(data(1:end-1,6)./mean(data(1:end-1,6)));
% data_investment = log(data(1:end-1,3)./mean(data(1:end-1,3)));
% data_consumption = log(data(1:end-1,7)./mean(data(1:end-1,7)));
% data_labor = log(data(1:end-1,8)./mean(data(1:end-1,8)));

data_growth = data(idx:end,2) - mean(data(idx:end,2));
data_r = log(data(idx:end,5)./mean(data(idx:end,5)));
data_inflation = log(data(idx:end,4)./mean(data(idx:end,4)));
data_rlong = log(data(idx:end,6)./mean(data(idx:end,6)));
data_investment = log(data(idx:end,3)./mean(data(idx:end,3)));
data_consumption = log(data(idx:end,7)./mean(data(idx:end,7)));
data_labor = log(data(idx:end,8)./mean(data(idx:end,8)));

dataEst = [data_growth data_r data_labor data_rlong data_investment];
dataEst = array2table(dataEst, 'VariableNames', {'data_growth','data_r','data_labor','data_rlong','data_investment'});
filename = 'opt_qe_estimation.xlsx';
delete(filename)
writetable(dataEst,filename);

EPSW = 6;
EPSP = 6;
SPREAD = 135;
DELTA = 0.025;
ALPHA = 1/3;
DURATION = 40;
TREAS2DEBT = 0.4;
ETA = 2;
GAMMA = 2;

pinf = 1;
h = 1/3;
phi = 6;
r = 1.02^0.25;
re = 0;
            
PHII = 2;
PHIN = 1;
PHIW = 0.75;
PHIP = 0.75;
RHOR = 0.8;
UPSIPI = 2;
UPSIY = 0.0;
RHORE1 =  0.941769097323668; % 1.021132476011252;
RHORE2 = 0; % -0.217764317642134;
RHOA = 0.9;
RHON = 0.9;
RHOF = 0.9;
RHOI = 0.9;
SIGA = 0.01;
SIGP = 0.01;
SIGF = 0.01;
SIGI = 0.01;
SIGR = 0.00752466565;
SIGRE = 0.469008625944446;

save params EPSW EPSP PHIW PHIP SPREAD DELTA ALPHA DURATION TREAS2DEBT ETA ...
            GAMMA pinf h phi r  re PHII PHIN RHOR UPSIPI UPSIY ...
            RHOA RHON RHOF RHOI SIGA SIGP SIGF SIGI SIGR SIGRE ...
            RHORE1 RHORE2
dynare base.mod noclearall
base_paramfile
base_ss_defs

save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW ...
                BG EPSF NSS pinf SP SK SW
dynare base_new.mod noclearall

%% clean-up folder
delete('*_results.mat')
delete('*.log')
delete('*.asv')
delete('*.jnl')
delete('*_static.m')
delete('*_dynamic.m')
delete('*_auxiliary_variables.m')

delete('base.m')
rmdir('base','s')

delete('base_new.m')
rmdir('base_new','s')