clear
cls
set more off
ssc install freduse
ssc install bgshade
ssc install xtscc
#delimit ;
cd "C:\Users\Ron Mau\Google Drive\Research\Optimal Monetary Policy Term Premium\Matlab Replication\estimation";

set fredkey 4207ade844d0e8e80db0b24d2312a719;

local macro	// Personal Consumption Expenditures: Chain-type Price Index
			PCEPI
			// Personal Consumption Expenditures: Durable Goods
			PCEDG
			// Gross Private Domestic Investment 
			GPDI
			// Personal Consumption Expenditures
			PCEC
			// 10-Year Treasury Constant Maturity Minus Federal Funds Rate
			T10YFFM
			// Federal Funds Effective Rate
			FEDFUNDS
			// Nonfarm Business Sector: Average Weekly Hours Worked for All Employed Persons
			PRS85006023;

import fred `macro', aggregate(quarterly, eop) clear;

g year = year(daten);
g quarter = quarter(daten);
g date = yq(year,quarter);
		label var date "Time (Quarter)";
tsset date, quarterly;

g output = (PCEC + GPDI)/PCEPI*100;
g lnOutput = ln(output);
g output_obs = d.lnOutput;

g inv_obs = GPDI/(GPDI+PCEC);
g cons_obs = 1-inv_obs;
g lab_obs = PRS85006023;

g lnDeflator = ln(PCEPI);
g inf_obs = 1+d.lnDeflator;

g fedfunds_obs = (1+FEDFUNDS/100)^0.25;
g r10_obs = (1+(FEDFUNDS+T10YFFM)/100)^0.25;

keep if date<yq(2009,1);
keep if date>=yq(1960,1);

export excel date output_obs inv_obs inf_obs fedfunds_obs r10_obs cons_obs lab_obs
	using ./estimation_data.xlsx, 
	replace firstrow(variables);