clc;
clear all;
close all;

addpath('d:\dynare\4.4.3\matlab')
addpath('C:\Users\Ron Mau\Google Drive\Research\Toolboxes\nash_ramsey_toolbox')

lambda_vec = nan([5,2]);
P_vec = lambda_vec;

EPSW = 6;
EPSP = 6;
SPREAD = 135;
DELTA = 0.025;
ALPHA = 1/3;
DURATION = 40;
TREAS2DEBT = 0.4;
ETA = 2;

pinf = 1;
h = 1/3;
phi = 6;
r = 1.02^0.25;
re = 0;
            
GAMMA = 2;
PHII = 2;
PHIW = 0.0;
PHIP = 0.0;
PHIN = 0;
RHOR = 0.8;
UPSIPI = 2.0;
UPSIY = 0.0;

load ./estimation/base_new_mean.mat
for it = 1:size(parameter_names,1)
    eval([parameter_names{it} '= xparam1(' num2str(it) ');'])
end

RHORE1 = 0.950712191157027;
RHORE2 = 0;
SIGRE = 0.0;

save params EPSW EPSP PHIW PHIP SPREAD DELTA ALPHA DURATION TREAS2DEBT ETA ...
            GAMMA pinf h phi r  re PHII PHIN RHOR UPSIPI UPSIY ...
            RHOA RHON RHOF RHOI SIGA SIGP SIGF SIGI SIGR SIGRE ...
            RHORE1 RHORE2
       
dynare base.mod noclearall

base_paramfile
base_ss_defs

shocks = {'ea','en','ef','ei','er','eb'};
log_vars = {'welfhh','Util1','Util2','y','yw','c','k','inv','h','f','n','phi','b','bcb','re','mc','wh','w','wstar','pk','xi','q','qeh','epsa','epsf','epsi','epsn'}; 
level_vars = {'bal2y'}; 
level_ann_vars = {'r','pinf','real','rl','rlong','rlongeh','tp','epinf'}; 

for it = 1:size(shocks,2)
    for it2 = 1:size(log_vars,2)
        eval(['irf.rbc.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.rbc.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.rbc.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

PHIW = 0.75;
PHIP = 0.75;
save params EPSW EPSP PHIW PHIP SPREAD DELTA ALPHA DURATION TREAS2DEBT ETA ...
            GAMMA pinf h phi r y re PHII PHIN RHOR UPSIPI UPSIY ...
            RHOA RHON RHOF RHOI SIGA SIGP SIGF SIGI SIGR SIGRE ...
            RHORE1 RHORE2
       
base
base_paramfile
base_ss_defs

for it = 1:size(shocks,2)
    for it2 = 1:size(log_vars,2)
        eval(['irf.nk.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.nk.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.nk.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

PHIN = 0.4295;
save params EPSW EPSP PHIW PHIP SPREAD DELTA ALPHA DURATION TREAS2DEBT ETA ...
            GAMMA pinf h phi r y re PHII PHIN RHOR UPSIPI UPSIY ...
            RHOA RHON RHOF RHOI SIGA SIGP SIGF SIGI SIGR SIGRE ...
            RHORE1 RHORE2
base
base_paramfile
base_ss_defs

for it = 1:size(shocks,2)
    for it2 = 1:size(log_vars,2)
        eval(['irf.base.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.base.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.base.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

RHOB = 0; 
NUTP = 0;
NUSLOPE = 0;
UPSIN = 0;
UPSITP = 0;
UPSISLOPE = 0;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RHOB NUTP NUSLOPE UPSIN UPSITP UPSISLOPE
dynare base_new noclearall
lambda_vec(1,1) = lambda;
lambda_vec(1,2) = lambda_vec(1,1);
base_new_paramfile
base_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.base_new.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.base_new.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.base_new.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

% MONETARY POLICY COMMITMENT
RPEG = 0;
REPEG = 0;
TAYLOR = 0;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
dynare ramsey noclearall
lambda_vec(2,1) = lambda;
P_vec(2,1) = P;
ramsey_paramfile
ramsey_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.ramsey.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.ramsey.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.ramsey.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

REPEG = 1;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
ramsey
lambda_vec(3,1) = lambda;
P_vec(3,1) = P;
ramsey_paramfile
ramsey_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.optint.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.optint.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.optint.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

RPEG = 1;
REPEG = 0;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
ramsey
lambda_vec(4,1) = lambda;
P_vec(4,1) = P;
ramsey_paramfile
ramsey_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.optre.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.optre.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.optre.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

TAYLOR = 1;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
ramsey
lambda_vec(5,1) = lambda;
P_vec(5,1) = P;
ramsey_paramfile
ramsey_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.optreTay.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.optreTay.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.optreTay.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

% MONETARY POLICY DISCRETION
RPEG = 0;
REPEG = 0;
TAYLOR = 0;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
dynare discretion.mod noclearall
lambda_vec(2,2) = lambda;
P_vec(2,2) = P;
ramsey_paramfile
discretion_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.disc.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.disc.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.disc.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

RPEG = 0;
REPEG = 1;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
discretion
lambda_vec(3,2) = lambda;
P_vec(3,2) = P;
ramsey_paramfile
discretion_ss_defs
for it = 1:size(shocks,2)-2
    for it2 = 1:size(log_vars,2)
        eval(['irf.discInt.' log_vars{it2} '_' shocks{it} '= 100*' log_vars{it2} '_' shocks{it} '/' log_vars{it2} ';']);
    end
    for it2 = 1:size(level_vars,2)
        eval(['irf.discInt.' level_vars{it2} '_' shocks{it} '= 100*' level_vars{it2} '_' shocks{it} ';']);
    end
    for it2 = 1:size(level_ann_vars,2)
        eval(['irf.discInt.' level_ann_vars{it2} '_' shocks{it} '= 400*' level_ann_vars{it2} '_' shocks{it} ';']);
    end
end

RPEG = 1;
REPEG = 0;
TAYLOR = 1;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
discretion
lambda_vec(5,2) = lambda;
P_vec(5,2) = P;

% LOOP NECESSARY FOR CREATING FIGURE 4
num = 21; % set to 101 to match paper figure
EPSP_vec = linspace(3,21,num);
EPSW_vec = linspace(3,10,num);
PHIN_vec = linspace(0.1,3,num);
PHII_vec = linspace(0.1,3,num);
inf_mat = nan([4,num,2]);

for it = 1:size(EPSP_vec,2)
    EPSP = EPSP_vec(it);
    RPEG = 0;
    REPEG = 0;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    ramsey
    P1 = P;

    discretion
    L2 = lambda;
    P2 = P;

    RPEG = 0;
    REPEG = 1;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    discretion
    P3 = P;
    L3 = lambda;

    inf_mat(1,it,1) = P2 - P1;
    inf_mat(1,it,2) = P3 - P1;
end
EPSP = 6;

for it = 1:size(EPSW_vec,2)
    EPSW = EPSW_vec(it);
    RPEG = 0;
    REPEG = 0;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    ramsey
    P1 = P;

    discretion
    L2 = lambda;
    P2 = P;
    
    RPEG = 0;
    REPEG = 1;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    discretion
    P3 = P;
    L3 = lambda;

    inf_mat(2,it,1) = P2 - P1;
    inf_mat(2,it,2) = P3 - P1;
end
EPSW = 6;

for it = 1:size(PHIN_vec,2)
    PHIN = PHIN_vec(it);
    RPEG = 0;
    REPEG = 0;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    ramsey
    P1 = P;
    
    discretion
    L2 = lambda;
    P2 = P;
    
    RPEG = 0;
    REPEG = 1;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    discretion
    P3 = P;
    L3 = lambda;

    inf_mat(3,it,1) = P2 - P1;
    inf_mat(3,it,2) = P3 - P1;
end
PHIN = 0.4295;

for it = 1:size(PHII_vec,2)
    PHII = PHII_vec(it);
    RPEG = 0;
    REPEG = 0;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    ramsey
    P1 = P;
    
    discretion
    L2 = lambda;
    P2 = P;
    
    RPEG = 0;
    REPEG = 1;
    TAYLOR = 0;
    save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RPEG REPEG TAYLOR
    discretion
    P3 = P;
    L3 = lambda;

    inf_mat(4,it,1) = P2 - P1;
    inf_mat(4,it,2) = P3 - P1;
end
PHII = 2;

% FIGURE 4 LEFT-HAND SIDE
figure(1)
plot(EPSP_vec./(EPSP_vec-1),inf_mat(1,end:-1:1,2),'color',[0 32 91]/255,'linewidth',2); hold on
plot(EPSW_vec./(EPSW_vec-1),inf_mat(2,end:-1:1,2),'--','color',[0 107 166]/255,'linewidth',2); hold off
    set(gca,'fontname', 'times','fontsize',14,'YGrid', 'on', 'XGrid', 'off');
    xlabel('Good/labor market monopolistic distortion','fontname', 'times','fontsize',16)
    ylabel('Annualized net inflation rate','fontname', 'times','fontsize',16)
    xlim([1.05 1.5])
    legend({'Goods','Labor'},'fontname','times','fontsize',16,'location','best')
    % print ../figures_replic/bias_markup -depsc

% FIGURE 4 RIGHT-HAND SIDE
figure(2)
plot(PHIN_vec,inf_mat(3,:,2),'color',[0 32 91]/255,'linewidth',2); hold on
plot(PHII_vec,inf_mat(4,:,2),'--','color',[0 107 166]/255,'linewidth',2); hold off
    set(gca,'fontname', 'times','fontsize',14,'YGrid', 'on', 'XGrid', 'off');
    ylabel('Annualized net inflation rate','fontname', 'times','fontsize',16)
    xlabel('Investment/equity adjustment cost parameter','fontname', 'times','fontsize',16)
    legend({'Equity','Investment'},'fontname','times','fontsize',16,'location','best')
    % print ../figures_replic/bias_adjustment -depsc

P_vec = P_vec(2:end,:)
P_diff = P_vec-P_vec(1:1)

lambda_vec
lambda_diff = lambda_vec(1,1)-lambda_vec(2:end,:)
rel_perf = lambda_diff/lambda_diff(1,1)

RHOB = 0; 
NUTP = 0; % 10000000000
NUSLOPE = 0; % 10000000000
RHOR = 0.8;
UPSIN = 0.0; % 0.5
UPSIPI = 2.0;
UPSITP = -0.0; % -8.50;
UPSISLOPE = -0.0; % -2.75
UPSIY = 0.0; % 0.5;
save params_new BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PHIP ...
                PHIW PHII PHIN RHOR UPSIPI UPSIY ...
                BG RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR ...
                RHORE1 RHORE2 SIGRE NSS pinf RHOB NUTP NUSLOPE UPSIN UPSITP UPSISLOPE
base_new
lambda
%% FIGURES
varlist = {'y','c','h','inv','rlong','tp','n','phi','r','epinf','bal2y'};
varnames = {'Output','Consumption','Labor','Investment',...
            '10-Year Yield','Term Premium','Bank Equity',...
            'Risk-weighted Leverage','Policy Rate','Expected Inflation',...
            'CB Balance Sheet-to-GDP'};
shocklist = {'epsa','epsn','epsf','epsi'};
shocknames = {'Technology','Preference','Financial','MEI'};

% FIGURES 2 - 3 and APPENDIX FIGURES 1 - 2
for its = 1:size(shocklist,2)
    figure('units','normalized','outerposition',[0 0 1 1])
    for itv = 1:size(varlist,2)
        subplot(3,4,itv)
        eval(['plot(0:20,irf.ramsey.' varlist{itv} '_' shocks{its} ',''color'',[0 32 91]/255,''linewidth'',4)'])
        hold on;
        eval(['plot(0:20,irf.base.' varlist{itv} '_' shocks{its} ',''-.'',''color'',[0 107 166]/255,''linewidth'',4)'])
        eval(['plot(0:20,irf.optint.' varlist{itv} '_' shocks{its} ',''--'',''color'',[204 9 47]/255,''linewidth'',4)'])
        eval(['plot(0:20,irf.discInt.' varlist{itv} '_' shocks{its} ','':'',''color'',[116 118 121]/255,''linewidth'',5)'])
        %eval(['plot(0:20,irf.peg.' varlist{itv} '_' shocks{its} ',''x'',''color'',[0 32 91]/255,''linewidth'',3,''markersize'',12)'])
        plot(0:20,zeros(size(0:20)),'k','linewidth',2); 
        hold off;
        set(gca,'fontname', 'times','fontsize',24,'YGrid', 'on', 'XGrid', 'off');
        eval(['title(''' varnames{itv} ''',''fontname'',''times'',''fontsize'',30,''FontWeight'',''Normal'')'])
    end
    subplot(3,4,12)
    eval(['plot(0:20,irf.ramsey.' shocklist{its} '_' shocks{its} ',''color'',[0 32 91]/255,''linewidth'',4)'])
    hold on;
    eval(['plot(0:20,irf.base.' shocklist{its} '_' shocks{its} ',''-.'',''color'',[0 107 166]/255,''linewidth'',4)'])
    eval(['plot(0:20,irf.optint.' shocklist{its} '_' shocks{its} ',''--'',''color'',[204 9 47]/255,''linewidth'',4)'])
    eval(['plot(0:20,irf.discInt.' shocklist{its} '_' shocks{its} ','':'',''color'',[116 118 121]/255,''linewidth'',5)'])
    %eval(['plot(0:20,irf.peg.' shocklist{its} '_' shocks{its} ',''x'',''color'',[0 32 91]/255,''linewidth'',3,''markersize'',14)'])
    plot(0:20,zeros(size(0:20)),'k','linewidth',2); 
    hold off;
    legend({'Dual (C)','FNK','Bal. Peg (C)','Bal. Peg (D)'},'fontname','times','fontsize',24,'location','best')
    legend boxoff
    set(gca,'fontname', 'times','fontsize',24,'YGrid', 'on', 'XGrid', 'off');
    eval(['title(''' shocknames{its} ''',''fontname'',''times'',''fontsize'',30,''FontWeight'',''Normal'')'])
    % eval(['print ../figures_replic/irf_' shocklist{its} ' -depsc'])
end

% APPENDIX FIGURES 1 - 4
for its = 1:size(shocklist,2)
    figure('units','normalized','outerposition',[0 0 1 1])
    for itv = 1:size(varlist,2)
        subplot(3,4,itv)
        eval(['plot(0:20,irf.ramsey.' varlist{itv} '_' shocks{its} ',''color'',[0 32 91]/255,''linewidth'',4)'])
        hold on;
        eval(['plot(0:20,irf.base.' varlist{itv} '_' shocks{its} ',''-.'',''color'',[0 107 166]/255,''linewidth'',4)'])
        eval(['plot(0:20,irf.rbc.' varlist{itv} '_' shocks{its} ',''--'',''color'',[204 9 47]/255,''linewidth'',4)'])
        %eval(['plot(0:20,irf.peg.' varlist{itv} '_' shocks{its} ',''x'',''color'',[0 32 91]/255,''linewidth'',3,''markersize'',12)'])
        plot(0:20,zeros(size(0:20)),'k','linewidth',2); 
        hold off;
        set(gca,'fontname', 'times','fontsize',24,'YGrid', 'on', 'XGrid', 'off');
        eval(['title(''' varnames{itv} ''',''fontname'',''times'',''fontsize'',30,''FontWeight'',''Normal'')'])
    end
    subplot(3,4,12)
    eval(['plot(0:20,irf.ramsey.' shocklist{its} '_' shocks{its} ',''color'',[0 32 91]/255,''linewidth'',4)'])
    hold on;
    eval(['plot(0:20,irf.base.' shocklist{its} '_' shocks{its} ',''-.'',''color'',[0 107 166]/255,''linewidth'',4)'])
    eval(['plot(0:20,irf.rbc.' shocklist{its} '_' shocks{its} ',''--'',''color'',[204 9 47]/255,''linewidth'',4)'])
    %eval(['plot(0:20,irf.peg.' shocklist{its} '_' shocks{its} ',''x'',''color'',[0 32 91]/255,''linewidth'',3,''markersize'',14)'])
    plot(0:20,zeros(size(0:20)),'k','linewidth',2); 
    hold off;
    legend({'Dual (C)','FNK','RBC'},'fontname','times','fontsize',24,'location','best')
    legend boxoff
    set(gca,'fontname', 'times','fontsize',24,'YGrid', 'on', 'XGrid', 'off');
    eval(['title(''' shocknames{its} ''',''fontname'',''times'',''fontsize'',30,''FontWeight'',''Normal'')'])
    % eval(['print ../figures_replic/irf_rbc_' shocklist{its} ' -depsc'])
end

close all

%% clean-up folder
delete('*.mat')
delete('*.log')
delete('*.asv')
delete('*.jnl')
delete('*_static.m')
delete('*_dynamic.m')
delete('*_auxiliary_variables.m')

delete('base.m')
rmdir('base','s')

delete('base_new.m')
rmdir('base_new','s')

delete('ramsey.m')
rmdir('ramsey','s')

delete('discretion.m')
rmdir('discretion','s')