warning off 
 
// Endogenous variables 
var welfhh, pinf, Util, 
Welf, 
instr1, 
instr2 Util1 Util2 
    y yw c k inv h hd f n phi re lamn lam r mc pstar x1 x2  
    vp wh w wstar g1 g2 vw pk xi q rl rlong qeh rlongeh tp bal2y epinf;  
 
// Exogenous variables 
var epsa epsf epsi epsn; 
 
varexo ea en ef ei; 
 
parameters  BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PINFSS RESS 
omega_welf1, 
omega_welf2, 
nbeta,            PHIP PHIW PHII PHIN RHOR UPSIPI UPSIY NSS BG 
            RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR YSS 
            RHORE1 RHORE2 SIGRE SK SW SP RPEG REPEG TAYLOR; 
 
var lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17,  lmult18,  lmult19,  lmult20,  lmult21,   
    lmult22,  lmult23,  lmult24,  lmult25,  lmult26,  lmult27,  lmult28,   
    lmult29,  lmult30,  lmult31,  lmult32,  lmult33,  lmult34,  lmult35,   
    lmult36,  lmult37,  lmult38,  lmult39, lmult40, lmult41,  Welf1,  Welf2; 
  
model; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
//// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
//// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = r; 
 
// Policy instrument, agent 2 
instr2 = re; 

// Policy constraint, interest rate
(1-RPEG)*lmult40 + RPEG*(log(r)-(1-TAYLOR)*log(PINFSS/BETA) - TAYLOR*(RHOR*log(r(-1)) + (1-RHOR)*(log(PINFSS/BETA) + UPSIPI*log(pinf/PINFSS))));

// Policy constraint, balance sheet
(1-REPEG)*lmult41 + REPEG*(re/y - RESS/YSS);
 
// OPTIMAL MONETARY POLICY 
// Policymaker's First-Order Conditions 
// Differentiating with respect to: c
(lmult37(-1)*((BETA*GAMMA*c(-1)*epsn*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*pinf) - (BETA*GAMMA*c(-1)*epsn*epsf(-1)*phi(-1)*rl*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*pinf)))/nbeta - lmult37*((BETA*GAMMA*epsn(+1)*(r - phi*(r - rl(+1)))*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*epsf*epsn(+1)*phi*rl(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1))) - (epsn*lmult12)/c^GAMMA - (epsn*lmult13)/c^GAMMA - lmult39 - GAMMA*PSI*c^(GAMMA - 1)*h^ETA*lmult15 + (BETA*GAMMA*epsn(+1)*lmult23*(pk(+1)*xi(+1)*(DELTA - 1) - (ALPHA*mc(+1)*yw(+1)*(SK + 1))/k)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*epsn(+1)*lmult14*r*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*epsn(+1)*lmult25*(c/c(+1))^(GAMMA - 1)*(KAPPA*q(+1)*xi(+1) + 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*PHIP*epsn(+1)*lmult30*pinf(+1)^(EPSP - 1)*x2(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*ZETA*epsn(+1)*lmult36*(r - phi*(r - rl(+1)))*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*c(-1)*epsn*lmult23(-1)*(pk*xi*(DELTA - 1) - (ALPHA*mc*yw*(SK + 1))/k(-1))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) - (BETA*GAMMA*PHIW*epsn(+1)*g1(+1)*lmult17*pinf(+1)^EPSW*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*PHIP*epsn(+1)*lmult29*pinf(+1)^EPSP*x1(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*PHIW*epsn(+1)*g2(+1)*lmult18*pinf(+1)^(EPSW - 1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) + (BETA*GAMMA*c(-1)*epsn*lmult14(-1)*r(-1)*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*c(-1)*epsn*lmult25(-1)*(c(-1)/c)^(GAMMA - 1)*(KAPPA*q*xi + 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*PHIW*c(-1)*epsn*g2*lmult18(-1)*pinf^(EPSW - 1)*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*PHIP*c(-1)*epsn*lmult30(-1)*pinf^(EPSP - 1)*x2*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*ZETA*c(-1)*epsn*lmult36(-1)*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*PHIW*c(-1)*epsn*g1*lmult17(-1)*pinf^EPSW*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*PHIP*c(-1)*epsn*lmult29(-1)*pinf^EPSP*x1*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) - (BETA*GAMMA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*lmult24*pk(+1)*xi(+1)*(c/c(+1))^(GAMMA - 1)*(inv(+1)/inv - 1))/(c(+1)*epsn*inv^2*xi) + (BETA*GAMMA*PHII*c(-1)*epsi*epsn*inv^2*lmult24(-1)*pk*xi*(c(-1)/c)^(GAMMA - 1)*(inv/inv(-1) - 1))/(c^2*epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 

// Differentiating with respect to: f
- lmult3(+1)*nbeta - lmult27*q - lmult38*q; 
lmult3 + (KAPPA*lmult27*q)/pinf; 

// Differentiating with respect to: g1
lmult17 - (EPSW*lmult16*(SW + 1))/(g2*(EPSW - 1)) - (BETA*PHIW*epsn*lmult17(-1)*pinf^EPSW*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 

// Differentiating with respect to: g2
lmult18 + (EPSW*g1*lmult16*(SW + 1))/(g2^2*(EPSW - 1)) - (BETA*PHIW*epsn*lmult18(-1)*pinf^(EPSW - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 

// Differentiating with respect to: h
lmult19 + PSI*epsn*h^ETA*lmult12 + PSI*epsn*h^ETA*lmult13 - ETA*PSI*c^GAMMA*h^(ETA - 1)*lmult15; 

// Differentiating with respect to: hd
(epsa*k(-1)^ALPHA*lmult31*(ALPHA - 1))/hd^ALPHA - lmult18*w^EPSW - lmult17*w^EPSW*wh - lmult19*vw - (lmult22*mc*yw*(ALPHA - 1)*(SP + 1))/hd^2; 

// Differentiating with respect to: inst1
lmult1; 

// Differentiating with respect to: inst2
lmult2; 

// Differentiating with respect to: inv
lmult27 - lmult39 - lmult4(+1)*nbeta + lmult26*(epsi*((PHII*(inv/inv(-1) - 1)^2)/2 - 1) + (PHII*epsi*inv*(inv/inv(-1) - 1))/inv(-1)) + lmult24*(epsi*pk*((2*PHII*(inv/inv(-1) - 1))/inv(-1) + (PHII*inv)/inv(-1)^2) + (BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^3*pk(+1)*xi(+1)*(c/c(+1))^GAMMA)/(epsn*inv^4*xi) + (2*BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*pk(+1)*xi(+1)*(c/c(+1))^GAMMA*(inv(+1)/inv - 1))/(epsn*inv^3*xi)) - (lmult24(-1)*((BETA*PHII*epsi*epsn*inv^2*pk*xi*(c(-1)/c)^GAMMA)/(epsn(-1)*inv(-1)^3*xi(-1)) + (2*BETA*PHII*epsi*epsn*inv*pk*xi*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*xi(-1))))/nbeta - epsi(+1)*lmult24(+1)*nbeta*pk(+1)*((PHII*inv(+1)^2)/inv^3 + (2*PHII*inv(+1)*(inv(+1)/inv - 1))/inv^2); 
lmult4 - (PHII*epsi*inv^2*lmult26*(inv/inv(-1) - 1))/inv(-1)^2; 

// Differentiating with respect to: k
lmult26 - lmult5(+1)*nbeta + (ALPHA*BETA*epsn(+1)*lmult23*mc(+1)*yw(+1)*(c/c(+1))^GAMMA*(SK + 1))/(epsn*k^2); 
lmult5 + lmult26*(DELTA - 1) - ALPHA*epsa*hd^(1 - ALPHA)*k(-1)^(ALPHA - 1)*lmult31; 

// Differentiating with respect to: mc
(lmult22*yw*(ALPHA - 1)*(SP + 1))/hd - lmult29*y - (ALPHA*BETA*epsn*lmult23(-1)*yw*(c(-1)/c)^GAMMA*(SK + 1))/(epsn(-1)*k(-1)*nbeta); 

// Differentiating with respect to: n
lmult36*((2*PHIN*(n/NSS - 1))/NSS + (PHIN*n)/NSS^2) - lmult6(+1)*nbeta + lmult38*phi; 
lmult6; 

// Differentiating with respect to: phi
lmult37*((BETA*epsn(+1)*(c/c(+1))^GAMMA*(r - rl(+1)))/(epsn*pinf(+1)) + (BETA*epsf*epsn(+1)*rl(+1)*(c/c(+1))^GAMMA)/(epsn*pinf(+1))) + lmult38*n + (BETA*ZETA*epsn(+1)*lmult36*(c/c(+1))^GAMMA*(r - rl(+1)))/(epsn*pinf(+1)); 

// Differentiating with respect to: pinf
(lmult37(-1)*((BETA*epsn*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf^2) - (BETA*epsn*epsf(-1)*phi(-1)*rl*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf^2)))/nbeta - PHIP*lmult34*pinf^(EPSP - 2)*(EPSP - 1) - PHIW*lmult21*pinf^(EPSW - 2)*w(-1)^(1 - EPSW)*(EPSW - 1) - EPSP*PHIP*lmult33*pinf^(EPSP - 1)*vp(-1) - (KAPPA*f(-1)*lmult27*q)/pinf^2 - EPSW*PHIW*lmult20*pinf^(EPSW - 1)*vw(-1)*(w/w(-1))^EPSW + (BETA*epsn*lmult14(-1)*r(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf^2) + (BETA*epsn*lmult25(-1)*(c(-1)/c)^GAMMA*(KAPPA*q*xi + 1))/(epsn(-1)*nbeta*pinf^2) + (BETA*ZETA*epsn*lmult36(-1)*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf^2) - (BETA*PHIW*epsn*g2*lmult18(-1)*pinf^(EPSW - 2)*(c(-1)/c)^GAMMA*(EPSW - 1))/(epsn(-1)*nbeta) - (BETA*PHIP*epsn*lmult30(-1)*pinf^(EPSP - 2)*x2*(c(-1)/c)^GAMMA*(EPSP - 1))/(epsn(-1)*nbeta) - (BETA*EPSW*PHIW*epsn*g1*lmult17(-1)*pinf^(EPSW - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta) - (BETA*EPSP*PHIP*epsn*lmult29(-1)*pinf^(EPSP - 1)*x1*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta)+ TAYLOR*(1-RHOR)*UPSIPI/pinf*lmult40; 

// Differentiating with respect to: pk
lmult23*xi + epsi*lmult24*((PHII*(inv/inv(-1) - 1)^2)/2 + (PHII*inv*(inv/inv(-1) - 1))/inv(-1) - 1) + (BETA*epsn*lmult23(-1)*xi*(c(-1)/c)^GAMMA*(DELTA - 1))/(epsn(-1)*nbeta) - (BETA*PHII*epsi*epsn*inv^2*lmult24(-1)*xi*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 

// Differentiating with respect to: pstar
lmult28 - (EPSP*lmult33*(PHIP - 1))/pstar^(EPSP + 1) - (lmult34*(EPSP - 1)*(PHIP - 1))/pstar^EPSP; 

// Differentiating with respect to: q
lmult25*xi - lmult7(+1)*nbeta - lmult27*(f - (KAPPA*f(-1))/pinf) - lmult38*(BG + f) - (KAPPA*lmult35)/q(-1) - (BETA*KAPPA*epsn*lmult25(-1)*xi*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf); 
lmult7 + (lmult35*(KAPPA*q + 1))/q(-1)^2; 

// Differentiating with respect to: r
(BETA*epsn(+1)*lmult37*(c/c(+1))^GAMMA*(phi - 1))/(epsn*pinf(+1)) - lmult8(+1)*nbeta - (BETA*epsn(+1)*lmult14*(c/c(+1))^GAMMA)/(epsn*pinf(+1)) - lmult1 + (BETA*ZETA*epsn(+1)*lmult36*(c/c(+1))^GAMMA*(phi - 1))/(epsn*pinf(+1)) - lmult40*RPEG; 
lmult8 + TAYLOR*RHOR/r(-1)*lmult40; 

// Differentiating with respect to: re
lmult38 - lmult2 - lmult41/y; 

// Differentiating with respect to: rl
lmult35 - (lmult37(-1)*((BETA*epsn*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf) - (BETA*epsn*epsf(-1)*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf)))/nbeta - (BETA*ZETA*epsn*lmult36(-1)*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf); 

// Differentiating with respect to: Util1
lmult12 + omega_welf1; 

// Differentiating with respect to: Util2
lmult13 + omega_welf2; 

// Differentiating with respect to: vp
lmult33 - lmult9(+1)*nbeta - lmult32*y; 
lmult9 - PHIP*lmult33*pinf^EPSP; 

// Differentiating with respect to: vw
lmult20 - hd*lmult19 - lmult10(+1)*nbeta; 
lmult10 - PHIW*lmult20*pinf^EPSW*(w/w(-1))^EPSW; 

// Differentiating with respect to: w
lmult22 - lmult11(+1)*nbeta + lmult20*((EPSW*wstar*(PHIW - 1))/(w^2*(wstar/w)^(EPSW + 1)) - (EPSW*PHIW*pinf^EPSW*vw(-1)*(w/w(-1))^(EPSW - 1))/w(-1)) - (lmult21*(EPSW - 1))/w^EPSW - EPSW*hd*lmult18*w^(EPSW - 1) - EPSW*hd*lmult17*w^(EPSW - 1)*wh; 
lmult11 + (PHIW*lmult21*pinf^(EPSW - 1)*(EPSW - 1))/w(-1)^EPSW + (EPSW*PHIW*lmult20*pinf^EPSW*vw(-1)*w*(w/w(-1))^(EPSW - 1))/w(-1)^2; 

// Differentiating with respect to: wh
lmult15 - hd*lmult17*w^EPSW; 

// Differentiating with respect to: wstar
lmult16 - (lmult21*(EPSW - 1)*(PHIW - 1))/wstar^EPSW - (EPSW*lmult20*(PHIW - 1))/(w*(wstar/w)^(EPSW + 1)); 

// Differentiating with respect to: x1
lmult29 - (EPSP*lmult28)/(x2*(EPSP - 1)) - (BETA*PHIP*epsn*lmult29(-1)*pinf^EPSP*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 

// Differentiating with respect to: x2
lmult30 + (EPSP*lmult28*x1)/(x2^2*(EPSP - 1)) - (BETA*PHIP*epsn*lmult30(-1)*pinf^(EPSP - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 

// Differentiating with respect to: xi
lmult23*pk + lmult25*q + (BETA*epsn*lmult23(-1)*pk*(c(-1)/c)^GAMMA*(DELTA - 1))/(epsn(-1)*nbeta) - (BETA*KAPPA*epsn*lmult25(-1)*q*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf) + (BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*lmult24*pk(+1)*xi(+1)*(c/c(+1))^GAMMA*(inv(+1)/inv - 1))/(epsn*inv^2*xi^2) - (BETA*PHII*epsi*epsn*inv^2*lmult24(-1)*pk*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 

// Differentiating with respect to: y
lmult39 - lmult30 - lmult29*mc - lmult32*vp + lmult41*re/y^2; 

// Differentiating with respect to: yw
lmult31 + lmult32 + (lmult22*mc*(ALPHA - 1)*(SP + 1))/hd - (ALPHA*BETA*epsn*lmult23(-1)*mc*(c(-1)/c)^GAMMA*(SK + 1))/(epsn(-1)*k(-1)*nbeta); 

// 3  Utility 1: lmult3 
    Util1 = epsn*(c^(1-GAMMA)/(1-GAMMA) - PSI*h^(1+ETA)/(1+ETA)); 
// 4  Utility 2: lmult4 
    Util2 = epsn*(c^(1-GAMMA)/(1-GAMMA) - PSI*h^(1+ETA)/(1+ETA)); 
 
// MODEL 
// 5  Ex ante real rate 
//    real = r/pinf(+1); 
// 6  Consumption Euler equation 
    1 = lamn(+1)*r; 
// 7  Labor supply 
    wh = PSI*h^ETA*c^GAMMA; 
// 8  Nominal SDF 
    lamn = BETA*epsn/epsn(-1)*(c(-1)/c)^GAMMA/pinf; 
// 9  Real SDF 
    lam = lamn*pinf; 
// 10 Reset wage 
    wstar = (1+SW)*EPSW/(EPSW-1)*g1/g2; 
// 11 Wage numerator 
    g1 = wh*w^EPSW*hd+PHIW*lam(+1)*pinf(+1)^EPSW*g1(+1); 
// 12 Wage denominator 
    g2 = w^EPSW*hd+PHIW*lam(+1)*pinf(+1)^(EPSW-1)*g2(+1); 
// 13 Labor market clearing 
    h = hd*vw; 
// 14 Wage dispersion 
    vw = (1-PHIW)*(wstar/w)^(-EPSW)+PHIW*pinf^EPSW*(w/w(-1))^EPSW*vw(-1); 
// 15 Aggregate wage 
    w^(1-EPSW)=(1-PHIW)*wstar^(1-EPSW)+PHIW*pinf^(EPSW-1)*w(-1)^(1-EPSW); 
// 16 Labor demand 
    w = (1+SP)*mc*(1-ALPHA)*yw/hd; 
// 17 Capital return 
    pk*xi = lam(+1)*((1+SK)*mc(+1)*ALPHA*yw(+1)/k+(1-DELTA)*pk(+1)*xi(+1)); 
// 18 Optimal investment 
     1 = pk*epsi*(1 - PHII*(inv/inv(-1)-1)*inv/inv(-1) - PHII/2*(inv/inv(-1)-1)^2) 
        + lam(+1)*xi(+1)/xi*pk(+1)*epsi(+1)*PHII*(inv(+1)/inv-1)*(inv(+1)/inv)^2; 
// 19 Bond pricing 
    q*xi = lamn(+1)*(1+KAPPA*q(+1)*xi(+1)); 
// 20 Capital accumulation equation 
    k = (1-DELTA)*k(-1) + epsi*(1-PHII/2*(inv/inv(-1)-1)^2)*inv; 
// 21 Loan-in-advance constraint 
    inv = q*(f-KAPPA*f(-1)/pinf); 
// 22 Reset price 
    pstar = EPSP/(EPSP-1)*x1/x2; 
// 23 Price numerator 
    x1 = mc*y+PHIP*lam(+1)*pinf(+1)^EPSP*x1(+1); 
// 24 Price denominator 
    x2 = y+PHIP*lam(+1)*pinf(+1)^(EPSP-1)*x2(+1); 
// 25 Aggregate production 
    yw = epsa*k(-1)^ALPHA*hd^(1-ALPHA); 
// 26 Goods market clearing 
    yw = y*vp; 
// 27 Price dispersion 
    vp = (1-PHIP)*pstar^(-EPSP)+PHIP*pinf^EPSP*vp(-1); 
// 28 Inflation 
    1 = (1-PHIP)*pstar^(1-EPSP)+PHIP*pinf^(EPSP-1); 
// 29 Long-term rate 
    rl = (1+KAPPA*q)/q(-1); 
// 30 Equity adjustment 
    1+PHIN*n/NSS*(n/NSS-1)+PHIN/2*(n/NSS-1)^2 = ZETA*lamn(+1)*(r+(rl(+1)-r)*phi); 
// 31 Risk-weighted leverage constraint 
    epsf*phi*lamn(+1)*rl(+1) = lamn(+1)*(r+(rl(+1)-r)*phi); 
// 32 Risk-weighted leverage 
    phi*n = q*(f+BG)-re; 
// 33 Aggregate resource constraint 
    y = c + inv; 
// 34 Long-term yield 
    rlong = 1/q+KAPPA; 
// 35 Expectations hypothesis bond price 
    qeh = (1+KAPPA*qeh(+1))/r; 
// 36 Expectations hypothesis long-term yield 
    rlongeh = 1/qeh+KAPPA; 
// 37 Term premium 
    tp = rlong - rlongeh; 
 
// WELFARE MEASURE 
// 38 Household welfare 
    welfhh = Util1 + BETA*welfhh(+1); 
 
// 39 Expected inflation 
    epinf = pinf(+1); 
// 40 Relative size of the balance sheet 
    bal2y = re/y; 
 
// EXOGENOUS PROCESSES 
// 41 Technology 
    log(epsa) = RHOA*log(epsa(-1)) + SIGA*ea; 
// 42 Preferences 
    log(epsn) = RHON*log(epsn(-1)) - SIGP*en; 
// 43 Financial 
    log(epsf) = (1-RHOF)*log(EPSF) + RHOF*log(epsf(-1)) - SIGF*ef; 
// 44 Marginal efficiency of investment 
    log(epsi) = RHOI*log(epsi(-1)) + SIGI*ei; 
 
end; 
 
options_.noprint=1; 
steady; 
check; 
 
shocks; 
var ea = 1; 
var en = 1; 
var ef = 1; 
var ei = 1;  
end; 
 
stoch_simul(order=2,irf=0,nomoments);

ramsey_paramfile
W = welfhh + 0.5*oo_.dr.ghs2(oo_.dr.inv_order_var(1));
lambda = 100*(1 - (((1-BETA)*W + PSI*h^(1+ETA)/(1+ETA))*(1-GAMMA))^(1/(1-GAMMA))/c);
P = 100*((pinf + 0.5*oo_.dr.ghs2(oo_.dr.inv_order_var(2)))^4-1);

stoch_simul(order=1,irf=21,nograph,qz_zero_threshold=1e-8);